<?php

/*
 * ip2clue client function
 * Site: http://kernel.embedromix.ro/us/
 * Copyright: Catalin(ux) M. BOIE
 * License: GPLv3 or later
 */

$ip2clue_fd = -1;

/*
 * Lookup by IP country and other information
 */
function ip2clue_lookup($ip2clue_host, $ip2clue_port, $timeout, $ip)
{
	global $ip2clue_fd;

	$ret['ok'] = FALSE;

	if ($ip2clue_fd == -1) {
		$fd = @fsockopen($ip2clue_host, $ip2clue_port, $errno,
			$strerr, $timeout);
		if ($fd === FALSE) {
			$ret['errmsg'] = "Cannot connect to $ip2clue_host"
				. ":$ip2clue_port ($strerr)";
			return $ret;
		}

		$ip2clue_fd = $fd;
	}

	$h = fwrite($ip2clue_fd, "R$ip\n");
	if ($h === FALSE) {
		$ret['errmsg'] = "Cannot write to $ip2clue_host"
			. ":$ip2clue_port";
		close($ip2clue_fd);
		$ip2clue_fd = -1;
		return $ret;
	}

	$buf = fgets($ip2clue_fd, 8192);
	if ($buf === FALSE) {
		$ret['errmsg'] = "Cannot read from $ip2clue_host"
			. ":$ip2clue_port";
		close($ip2clue_fd);
		$ip2clue_fd = -1;
		return $ret;
	}

	if (strncmp($buf, "OK", 2) != 0) {
		$ret['errmsg'] = $buf;
		return $ret;
	}

	$buf = substr($buf, 2);
	$x = explode(" ", $buf);

	foreach ($x as $val) {
		$pair = explode("=", $val);
		$var = trim($pair[0]);

		if (strlen($var) == 0)
			continue;

		$val = trim($pair[1]);
		$ret[$var] = $val;
	}

	$ret['ok'] = TRUE;

	return $ret;
}

?>
